JUCE: Range< ValueType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Range< ValueType > Class Template Reference
juce_core » maths

A general-purpose range object, that simply represents any linear range with a start and end point. More...

`#include <juce_Range.h>`

## Public Member Functions
constexpr | Range ()=default
| Constructs an empty range.
constexpr | Range (const ValueType startValue, const ValueType endValue) noexcept
| Constructs a range with given start and end values.
constexpr | Range (const Range &)=default
| Constructs a copy of another range.
Range & | operator= (const Range &)=default
| Copies another range object.
constexpr ValueType | getStart () const noexcept
| Returns the start of the range.
constexpr ValueType | getLength () const noexcept
| Returns the length of the range.
constexpr ValueType | getEnd () const noexcept
| Returns the end of the range.
constexpr bool | isEmpty () const noexcept
| Returns true if the range has a length of zero.
void | setStart (const ValueType newStart) noexcept
| Changes the start position of the range, leaving the end position unchanged.
constexpr Range | withStart (const ValueType newStart) const noexcept
| Returns a range with the same end as this one, but a different start.
constexpr Range | movedToStartAt (const ValueType newStart) const noexcept
| Returns a range with the same length as this one, but moved to have the given start position.
void | setEnd (const ValueType newEnd) noexcept
| Changes the end position of the range, leaving the start unchanged.
constexpr Range | withEnd (const ValueType newEnd) const noexcept
| Returns a range with the same start position as this one, but a different end.
constexpr Range | movedToEndAt (const ValueType newEnd) const noexcept
| Returns a range with the same length as this one, but moved to have the given end position.
void | setLength (const ValueType newLength) noexcept
| Changes the length of the range.
constexpr Range | withLength (const ValueType newLength) const noexcept
| Returns a range with the same start as this one, but a different length.
constexpr Range | expanded (ValueType amount) const noexcept
| Returns a range which has its start moved down and its end moved up by the given amount.
Range | operator+= (const ValueType amountToAdd) noexcept
| Adds an amount to the start and end of the range.
Range | operator-= (const ValueType amountToSubtract) noexcept
| Subtracts an amount from the start and end of the range.
constexpr Range | operator+ (const ValueType amountToAdd) const noexcept
| Returns a range that is equal to this one with an amount added to its start and end.
constexpr Range | operator- (const ValueType amountToSubtract) const noexcept
| Returns a range that is equal to this one with the specified amount subtracted from its start and end.
constexpr bool | operator== (Range other) const noexcept
constexpr bool | operator!= (Range other) const noexcept
constexpr bool | contains (const ValueType position) const noexcept
| Returns true if the given position lies inside this range.
ValueType | clipValue (const ValueType value) const noexcept
| Returns the nearest value to the one supplied, which lies within the range.
constexpr bool | contains (Range other) const noexcept
| Returns true if the given range lies entirely inside this range.
constexpr bool | intersects (Range other) const noexcept
| Returns true if the given range intersects this one.
constexpr Range | getIntersectionWith (Range other) const noexcept
| Returns the range that is the intersection of the two ranges, or an empty range with an undefined start position if they don't overlap.
constexpr Range | getUnionWith (Range other) const noexcept
| Returns the smallest range that contains both this one and the other one.
constexpr Range | getUnionWith (const ValueType valueToInclude) const noexcept
| Returns the smallest range that contains both this one and the given value.
Range | constrainRange (Range rangeToConstrain) const noexcept
| Returns a given range, after moving it forwards or backwards to fit it within this range.

## Static Public Member Functions
static constexpr Range | between (const ValueType position1, const ValueType position2) noexcept
| Returns the range that lies between two positions (in either order).
static Range | withStartAndLength (const ValueType startValue, const ValueType length) noexcept
| Returns a range with a given start and length.
static constexpr Range | emptyRange (const ValueType start) noexcept
| Returns a range with the specified start position and a length of zero.
template<typename Integral , std::enable_if_t< std::is_integral_v< Integral >, int > = 0>
static Range | findMinAndMax (const ValueType *values, Integral numValues) noexcept
| Scans an array of values for its min and max, and returns these as a Range.

## Detailed Description

template<typename ValueType>
class Range< ValueType >

A general-purpose range object, that simply represents any linear range with a start and end point.

Note that when checking whether values fall within the range, the start value is considered to be inclusive, and the end of the range exclusive.

The templated parameter is expected to be a primitive integer or floating point type, though class types could also be used if they behave in a number-like way.

## Constructor & Destructor Documentation

## ◆ Range() [1/3]

template<typename ValueType >

constexpr Range< ValueType >::Range | ( |  | ) |
| constexprdefault

Constructs an empty range.

Referenced by Range< ValueType >::between(), Range< ValueType >::emptyRange(), Range< ValueType >::expanded(), Range< ValueType >::findMinAndMax(), Range< ValueType >::getIntersectionWith(), Range< ValueType >::getUnionWith(), Range< ValueType >::getUnionWith(), Range< ValueType >::movedToEndAt(), Range< ValueType >::movedToStartAt(), Range< ValueType >::operator+(), Range< ValueType >::operator-(), Range< ValueType >::withEnd(), Range< ValueType >::withLength(), Range< ValueType >::withStart(), and Range< ValueType >::withStartAndLength().

## ◆ Range() [2/3]

template<typename ValueType >

constexpr Range< ValueType >::Range | ( | const ValueType | startValue,
|  | const ValueType | endValue
| ) |  |
| constexprnoexcept

Constructs a range with given start and end values.

## ◆ Range() [3/3]

template<typename ValueType >

constexpr Range< ValueType >::Range | ( | const Range< ValueType > & |  | ) |
| constexprdefault

Constructs a copy of another range.

## Member Function Documentation

## ◆ operator=()

template<typename ValueType >

Range & Range< ValueType >::operator= | ( | const Range< ValueType > & |  | ) |
| default

Copies another range object.

## ◆ between()

template<typename ValueType >

static constexpr Range Range< ValueType >::between | ( | const ValueType | position1,
|  | const ValueType | position2
| ) |  |
| staticconstexprnoexcept

Returns the range that lies between two positions (in either order).

References Range< ValueType >::Range().

## ◆ withStartAndLength()

template<typename ValueType >

static Range Range< ValueType >::withStartAndLength | ( | const ValueType | startValue,
|  | const ValueType | length
| ) |  |
| staticnoexcept

Returns a range with a given start and length.

References jassert, and Range< ValueType >::Range().

Referenced by Rectangle< ValueType >::getHorizontalRange(), and Rectangle< ValueType >::getVerticalRange().

## ◆ emptyRange()

template<typename ValueType >

static constexpr Range Range< ValueType >::emptyRange | ( | const ValueType | start | ) |
| staticconstexprnoexcept

Returns a range with the specified start position and a length of zero.

References Range< ValueType >::Range().

## ◆ getStart()

template<typename ValueType >

constexpr ValueType Range< ValueType >::getStart | ( |  | ) | const
| constexprnoexcept

Returns the start of the range.

Referenced by Reservoir::doBufferedRead(), AudioData::Pointer< SampleFormat, Endianness, InterleavingType, Constness >::findMinAndMax(), SparseSet< Type >::getTotalRange(), and SparseSet< Type >::removeRange().

## ◆ getLength()

template<typename ValueType >

constexpr ValueType Range< ValueType >::getLength | ( |  | ) | const
| constexprnoexcept

Returns the length of the range.

Referenced by Range< ValueType >::constrainRange().

## ◆ getEnd()

template<typename ValueType >

constexpr ValueType Range< ValueType >::getEnd | ( |  | ) | const
| constexprnoexcept

Returns the end of the range.

Referenced by AudioData::Pointer< SampleFormat, Endianness, InterleavingType, Constness >::findMinAndMax(), SparseSet< Type >::getTotalRange(), and SparseSet< Type >::removeRange().

## ◆ isEmpty()

template<typename ValueType >

constexpr bool Range< ValueType >::isEmpty | ( |  | ) | const
| constexprnoexcept

Returns true if the range has a length of zero.

References exactlyEqual().

Referenced by SparseSet< Type >::addRange(), Reservoir::doBufferedRead(), and SparseSet< Type >::removeRange().

## ◆ setStart()

template<typename ValueType >

void Range< ValueType >::setStart | ( | const ValueType | newStart | ) |
| noexcept

Changes the start position of the range, leaving the end position unchanged.

If the new start position is higher than the current end of the range, the end point will be pushed along to equal it, leaving an empty range at the new position.

Referenced by Reservoir::doBufferedRead().

## ◆ withStart()

template<typename ValueType >

constexpr Range Range< ValueType >::withStart | ( | const ValueType | newStart | ) | const
| constexprnoexcept

Returns a range with the same end as this one, but a different start.

If the new start position is higher than the current end of the range, the end point will be pushed along to equal it, returning an empty range at the new position.

References jmax(), and Range< ValueType >::Range().

## ◆ movedToStartAt()

template<typename ValueType >

constexpr Range Range< ValueType >::movedToStartAt | ( | const ValueType | newStart | ) | const
| constexprnoexcept

Returns a range with the same length as this one, but moved to have the given start position.

References Range< ValueType >::Range().

## ◆ setEnd()

template<typename ValueType >

void Range< ValueType >::setEnd | ( | const ValueType | newEnd | ) |
| noexcept

Changes the end position of the range, leaving the start unchanged.

If the new end position is below the current start of the range, the start point will be pushed back to equal the new end point.

## ◆ withEnd()

template<typename ValueType >

constexpr Range Range< ValueType >::withEnd | ( | const ValueType | newEnd | ) | const
| constexprnoexcept

Returns a range with the same start position as this one, but a different end.

If the new end position is below the current start of the range, the start point will be pushed back to equal the new end point.

References jmin(), and Range< ValueType >::Range().

## ◆ movedToEndAt()

template<typename ValueType >

constexpr Range Range< ValueType >::movedToEndAt | ( | const ValueType | newEnd | ) | const
| constexprnoexcept

Returns a range with the same length as this one, but moved to have the given end position.

References Range< ValueType >::Range().

## ◆ setLength()

template<typename ValueType >

void Range< ValueType >::setLength | ( | const ValueType | newLength | ) |
| noexcept

Changes the length of the range.

Lengths less than zero are treated as zero.

References jmax().

## ◆ withLength()

template<typename ValueType >

constexpr Range Range< ValueType >::withLength | ( | const ValueType | newLength | ) | const
| constexprnoexcept

Returns a range with the same start as this one, but a different length.

Lengths less than zero are treated as zero.

References Range< ValueType >::Range().

## ◆ expanded()

template<typename ValueType >

constexpr Range Range< ValueType >::expanded | ( | ValueType | amount | ) | const
| constexprnoexcept

Returns a range which has its start moved down and its end moved up by the given amount.

Returns
  The returned range will be (start - amount, end + amount)

References Range< ValueType >::Range().

## ◆ operator+=()

template<typename ValueType >

Range Range< ValueType >::operator+= | ( | const ValueType | amountToAdd | ) |
| noexcept

Adds an amount to the start and end of the range.

## ◆ operator-=()

template<typename ValueType >

Range Range< ValueType >::operator-= | ( | const ValueType | amountToSubtract | ) |
| noexcept

Subtracts an amount from the start and end of the range.

## ◆ operator+()

template<typename ValueType >

constexpr Range Range< ValueType >::operator+ | ( | const ValueType | amountToAdd | ) | const
| constexprnoexcept

Returns a range that is equal to this one with an amount added to its start and end.

References Range< ValueType >::Range().

## ◆ operator-()

template<typename ValueType >

constexpr Range Range< ValueType >::operator- | ( | const ValueType | amountToSubtract | ) | const
| constexprnoexcept

Returns a range that is equal to this one with the specified amount subtracted from its start and end.

References Range< ValueType >::Range().

## ◆ operator==()

template<typename ValueType >

constexpr bool Range< ValueType >::operator== | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

Referenced by Range< ValueType >::operator!=().

## ◆ operator!=()

template<typename ValueType >

constexpr bool Range< ValueType >::operator!= | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

References Range< ValueType >::operator==().

## ◆ contains() [1/2]

template<typename ValueType >

constexpr bool Range< ValueType >::contains | ( | const ValueType | position | ) | const
| constexprnoexcept

Returns true if the given position lies inside this range.

When making this comparison, the start value is considered to be inclusive, and the end of the range exclusive.

Referenced by SparseSet< Type >::removeRange().

## ◆ clipValue()

template<typename ValueType >

ValueType Range< ValueType >::clipValue | ( | const ValueType | value | ) | const
| noexcept

Returns the nearest value to the one supplied, which lies within the range.

References jlimit().

## ◆ contains() [2/2]

template<typename ValueType >

constexpr bool Range< ValueType >::contains | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

Returns true if the given range lies entirely inside this range.

## ◆ intersects()

template<typename ValueType >

constexpr bool Range< ValueType >::intersects | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

Returns true if the given range intersects this one.

## ◆ getIntersectionWith()

template<typename ValueType >

constexpr Range Range< ValueType >::getIntersectionWith | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

Returns the range that is the intersection of the two ranges, or an empty range with an undefined start position if they don't overlap.

References jmax(), jmin(), and Range< ValueType >::Range().

Referenced by Reservoir::doBufferedRead().

## ◆ getUnionWith() [1/2]

template<typename ValueType >

constexpr Range Range< ValueType >::getUnionWith | ( | Range< ValueType > | other | ) | const
| constexprnoexcept

Returns the smallest range that contains both this one and the other one.

References jmax(), jmin(), and Range< ValueType >::Range().

## ◆ getUnionWith() [2/2]

template<typename ValueType >

constexpr Range Range< ValueType >::getUnionWith | ( | const ValueType | valueToInclude | ) | const
| constexprnoexcept

Returns the smallest range that contains both this one and the given value.

References jmax(), jmin(), and Range< ValueType >::Range().

## ◆ constrainRange()

template<typename ValueType >

Range Range< ValueType >::constrainRange | ( | Range< ValueType > | rangeToConstrain | ) | const
| noexcept

Returns a given range, after moving it forwards or backwards to fit it within this range.

If the supplied range has a greater length than this one, the return value will be this range.

Otherwise, if the supplied range is smaller than this one, the return value will be the new range, shifted forwards or backwards so that it doesn't extend beyond this one, but keeping its original length.

References Range< ValueType >::getLength(), and jlimit().

## ◆ findMinAndMax()

template<typename ValueType >
template<typename Integral , std::enable_if_t< std::is_integral_v< Integral >, int > = 0>

static Range Range< ValueType >::findMinAndMax | ( | const ValueType * | values,
|  | Integral | numValues
| ) |  |
| staticnoexcept

Scans an array of values for its min and max, and returns these as a Range.

References Range< ValueType >::Range().

Referenced by MemoryMappedAudioFormatReader::scanMinAndMaxInterleaved().

The documentation for this class was generated from the following file:

- juce_Range.h